#include<iostream.h>

#include"row.h"
#include"table.h"
#include"writer.h"
#include"reader.h"
#include"verticals.h"

int main(int argc, char* argv[]){
  Writer myWriter;
  Reader myReader;
  Verticals myVerticals;
  Row myRow;
  Table myTable;
  const char *outfile;
  const char *file_content;

  if(argc==1) myWriter.print_options();
  else{
    myReader.make_options(argc, argv);

    if(myReader.get_opt(10)*myReader.get_opt(11)!=0){
	myReader.set_dir();
	myReader.set_head(argc, argv);
	myReader.set_line_title(argc, argv);

 	myRow.make(myReader.get_line());
 	myTable.set_table(myReader, myRow);
 	if(myReader.get_opt(12)){ // no verticals
 	    outfile=myTable.print_table(myReader);
 	    file_content="_rows";
 	}
 	else{ // verticals
	    if(myRow.getPlithos()!=12){
		cout << "This is not a twelve-tone row" << endl;
		return 0;
	    }
	    else{
		myReader.in_form();
		outfile=myVerticals.create(myReader, myTable);
		file_content="_vert";
	    }
 	}
    }
    else{
	if(myReader.get_opt(10)==0) myWriter.print_options();
	else myWriter.print_version();
    }
  }
  return 0;
}
