#include"matrix.h"
#include<iostream.h>

Row Matrix::get_itsSeira(int position){
  return itsSeira[position];
}

int Matrix::chromatic_small(int x, int y){
   return(chromatic_big(x, y)%12);
}

void Matrix::filter1(void){
  for(int i=0; i<12; i++) itsSeira[i].filter1();
}

void Matrix::filter2(void){
  for(int i=0; i<12; i++) itsSeira[i].filter2();
}

void Matrix::filter3(void){
  for(int i=0; i<12; i++) itsSeira[i].filter3();
}

void Matrix::ambitus(void){
  for(int i=0; i<12; i++){
    itsSeira[i].ambitus();
    itsSeira[i].ambitus();
  }
}

int Matrix::chromatic_big(int x, int y){
  if(y%7<3) return(2*(y%7)+x+12*(y/7));
  else return(2*(y%7)+x-1+12*(y/7));
}

void Matrix::retrograde(void){
  for(int i=0; i<12; i++)
    itsSeira[i].retrograde();
}

void Matrix::invert(void){
  for(int i=0; i<12; i++)
    itsSeira[i].invert();
}

void Matrix::transpose(int position, Interval Diastima){
  itsSeira[position].transpose(Diastima);
}

//void make_matrix(int head, int quant[], char qual[], int plithos)//void make_matrix(int head, int quant[], char qual[], int plithos)
void Matrix::generate(Row Seira){
  int i, k;
  Interval List[12];
  interval_list(List);
  // Initialize the Matrix
  for(i=0; i<12; i++) itsSeira[i]=Seira;
  int head=chromatic_small(Seira.getNotes(0).getAccid(), 
			   Seira.getNotes(0).getHead());

// The first part of the array that involves all the 12
// transpositions of the given melodic line is being
// constructed. This part includes all transpositions from
// "head" to 12. (e.g. if head=3, and the melodic line is a
// P(rime) form, P(3), P(4), P(5), ..., P(12) are being
// constructed. 

  for(i=head; i<12; i++)
    itsSeira[i].transpose(List[i-head]);

  for(i=head-1; i>=0; i--){
      k=List[head-i].get_space()*(-1);
      List[head-i].set_space(k);
      itsSeira[i].transpose(List[head-i]);
  }
}

void Matrix::interval_list(Interval Diastimata[]){
  char types[]={'p', 'm', 'M', 'm', 'M', 'p', 'a', 'p', 'm', 'M', 'm', 'M'};
  int spaces[]={1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7};
  for(int i=0; i<12; i++){
    Diastimata[i].set_space(spaces[i]);
    Diastimata[i].set_type(types[i]);
  }
//    for(int i=0; i<12; i++){
//      cout << Diastimata[i].get_space() << Diastimata[i].get_type() << endl;
//    }
}
