#ifndef TABLE_H
#define TABLE_H

#include"matrix.h"
#include<fstream.h>
#include"reader.h"
#include"row.h"

class Table{
 public:
  Table();
  ~Table();
  void set_table(Reader myReader, Row myRow);
  char* print_table(Reader myReader);
  void set_options(Reader myReader);
  void set_title(char *titel);
  void set_filename(const char *name);
  void setForms(Row Seira);
  Matrix getForms(int position);
  void filter(void);
  void print(void);
 private:
  int accid_filt(Row Seira, int pos);
  void print_row(int slice_pos, int row_pos);
  void print_slice(int slice_pos);
  void print_score(void);
  void print_settings();
  void tetragono(void);
  void print_barline(void);
  void german_names(int x, int y, char g_note[]);
  char num2notename(int x);
  char num2accid(int x);
  int chromatic_big(int x, int y);
  int chromatic_small(int x, int y);
  char filename[20];
  char file_head[20];
  ofstream *texfile;
  char *title;
  void filter1(void);
  void filter2(void);
  void filter3(void);
  void ambitus(void);
  Matrix Forms[4];
  // OPTIONS
  // TeX options
  int end;
  int no_es;
  int no_double;
  int numbers;
  int filt1, filt2;
  int make_P, make_R, make_I, make_RI;
  // Format options
  int square;
  int arithm;
  // Information options
  int help, version;

};

#endif
