#include<fstream.h>
#include"writer.h"
#include<string.h>
#include<iomanip.h>

Writer::Writer(void){
}

Writer::~Writer(){
}

// SETTINGS
void Writer::set_options(Reader myReader){
  help=myReader.get_opt(10);
  version=myReader.get_opt(10);
}

void Writer::print(int argc){
  if(help==0 || argc==1) print_options();
  else if(version==0) print_version();
}

// INFORMATION, HELP
void Writer::print_version(void){
  cout << "\
TTRM version 2 (August 2002)

(C) Copyright by A. Droseltis
This is free software. See the documentation for more details.
It is distributed without any warranty.\
" << endl;
}

void Writer::print_options(void){
  cout << "\
SYNTAX: ttrm [OPTIONS] [FILE]
OPTIONS
-e          The command \\end will not be printed
            at the end of the .tex file. This is useful, when
            many .tex files should be included in an other file.
-n          The numbers 1-12 will not be printed under the notes.
-f1         The notes e sharp, f flat, b sharp and c flat will be printed,
            and not their enharmonic notes.
-f2         The use of double accidentals is enabled.
-P          Only the P transpositions are printed.
-R          Only the R transpositions are printed.
-I          Only the I transpositions are printed.
-RI         Only the RI transpositions are printed.
            (The four options above can be combined, e.g. -P -I, or -P -I -RI.)
-s          The square matrix is printed on the screen too (names of the 
            notes).
-ss         Only the square matrix is printed on the screen (names of the 
            notes).
-a          The square matrix is printed on the screen too (arithmetical).
-aa         Only the square matrix is printed on the screen (arithmetical).
-xdvi       Execute the TeX file and show the DVI file with xdvi.
--help      Print this information and exit.
--version   Print the number of the program's  version.
--verticals Print the tables with the Stravinkian Verticals.\
" << endl;
}
